# -*- coding: utf-8 -*-

from core.libs import *

QLT = Qualities({
    Qualities.rip: ['DVDRip', 'dvdrip', 'rhdtv', 'HDRip'],
    Qualities.hd_full: ['1080p', 'BluRay-1080p', 'BDremux-1080p', 'FullBluRay', 'MicroHD-1080p'],
    Qualities.uhd: ['4K-HDR', '4K'],
    Qualities.hd: ['BluRay-720p', 'hdtv', '720p', 'HDTV', 'HDTV-720p'],
    Qualities.scr: ['dvdscr', 'BR-Screener', 'DVDscreener'],
    Qualities.sd: ['sd']
})

HOST = 'http://www.mejortorrent.org/'

def mainlist(item):
    logger.trace()
    itemlist = list()

    # SubMenu Peliculas
    new_item = item.clone(
        type='label',
        label="Películas",
        category='movie',
        thumb='thumb/movie.png',
        icon='icon/movie.png',
        poster='poster/movie.png'
    )
    itemlist.append(new_item)
    itemlist.extend(menupeliculas(new_item))

    #SubMenu Series
    new_item = item.clone(
        type='label',
        label="Series",
        category='tvshow',
        thumb='thumb/tvshow.png',
        icon='icon/tvshow.png',
        poster='poster/tvshow.png',
    )
    itemlist.append(new_item)
    itemlist.extend(menuseries(new_item))

    return itemlist


def menupeliculas(item):
    logger.trace()
    itemlist = list()

    itemlist.append(item.clone(
        label="Novedades SD",
        action="newest_movies",
        content_type='movies',
        type="item",
        group=True,
        url=HOST + '/torrents-de-peliculas.html'
    ))

    itemlist.append(item.clone(
        label="Novedades HD",
        action="newest_movies",
        content_type='movies',
        type="item",
        group=True,
        url=HOST + '/torrents-de-peliculas-hd-alta-definicion.html'
    ))

    itemlist.append(item.clone(
        action="generos",
        label="Géneros",
        type="item",
        group=True,
        url=HOST + '/torrents-de-peliculas.html'
    ))

    itemlist.append(item.clone(
        action="abc",
        label="Películas por orden alfabético",
        url=HOST,
        type="item",
        group=True,
    ))

    itemlist.append(item.clone(
        action="search",
        label="Buscar",
        query=True,
        type='search',
        group=True,
        content_type='movies'
    ))

    return itemlist


def menuseries(item):
    logger.trace()
    itemlist = list()

    itemlist.append(item.clone(
        label="Nuevos episodios SD",
        action="newest_episodes",
        content_type='episodes',
        type="item",
        group=True,
        url=HOST + '/torrents-de-series.html',
        quality='sd'
    ))

    itemlist.append(item.clone(
        label="Nuevos episodios HD",
        action="newest_episodes",
        content_type='episodes',
        type="item",
        group=True,
        url=HOST + '/torrents-de-series-hd-alta-definicion.html'
    ))

    itemlist.append(item.clone(
        action="abc",
        label="Series por orden alfabético",
        url=HOST,
        type="item",
        group=True,
    ))

    itemlist.append(item.clone(
        action="search",
        label="Buscar",
        query=True,
        type='search',
        group=True,
        content_type='tvshows'
    ))

    return itemlist


def generos(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = scrapertools.find_single_match(data, "<select name='valor2'(.*?)</select>")

    for genero in scrapertools.find_multiple_matches(data,'<option[ selected]?>([^<]+)</option>'):
        itemlist.append(item.clone(
            label=unicode(genero, "iso-8859-1", errors="replace").encode("utf-8"),
            campo='genero',
            valor=genero,
            type='item',
            content_type='movies',
            action='listado_unico_peliculas',
            url=HOST + '/peliculas-buscador.html'
        ))

    return itemlist


def abc(item):
    logger.trace()
    itemlist = list()

    for letra in 'ABCDEFGHIJKLMNOPQRSTUVWXYZ':
        new_item = item.clone(
            label=letra,
            type='item'
        )

        if item.category == 'movie':
            new_item.campo = 'letra'
            new_item.valor = letra
            new_item.content_type='movies'
            new_item.action = 'listado_unico_peliculas'
            new_item.url = HOST + '/peliculas-buscador.html'
        else:
            new_item.content_type = 'tvshows'
            new_item.action = 'listado_unico_series'
            new_item.url = HOST + '/series-letra-%s.html' % letra.lower()


        itemlist.append(new_item)

    return itemlist


def search(item):
    logger.trace()


    item.url = HOST + '/secciones.php?sec=buscador&valor=%s' % item.query.replace(' ','+')
    data = httptools.downloadpage(item.url).data
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)
    data = scrapertools.find_single_match(data, '<br>Se han encontrado <b>(.*?)</table><br></td>')
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")

    patron = "<a href='([^']+)[^>]+>(.*?)</a>(.*?)</td></tr>"

    listado = []
    for url, title, type in scrapertools.find_multiple_matches(data, patron):
        if (item.category == 'movie' and 'Película' in type) or (item.category == 'tvshow' and 'Serie' in type):
            title = re.sub(r'<.*?>','', title)
            listado.append((url, title))

    if item.category == 'movie':
        return filtrar_peliculas(item, listado)
    else:
        return  filtrar_series(item, listado)


def listado_unico_series(item):
    logger.trace()

    data = httptools.downloadpage(item.url).data
    data = scrapertools.find_single_match(data, '<big>Mostrando <b>(.*?)</table><br></td>')
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    return filtrar_series(item,scrapertools.find_multiple_matches(data,"<td>\s?<a href='([^']+)'.*?>\s?([^<]+)</a>"))


def filtrar_series(item, series):
    logger.trace()
    itemlist = list()
    listado = {}
    for url, title in series:
        try:
            title = title.split('-')
            tvshowtitle = re.sub(r'\s?\.?\s?$', '', re.sub(r'[\(|\[].*[\)|\]]', '', title[0]))
            temporada = re.sub(r'\s?\.?\s?$', '', re.sub(r'[\(|\[].*[\)|\]]', '', title[1]))
            if 'miniserie' in temporada.lower():
                temporada = 1
            else:
                temporada = int(scrapertools.find_single_match(temporada,'(\d+)'))
        except:
            continue

        listado_temporadas = listado.get(tvshowtitle, {})
        listado_urls = listado_temporadas.get(temporada, [])
        listado_urls.append(HOST + url)
        listado_temporadas[temporada] = listado_urls
        listado[tvshowtitle] = listado_temporadas

    if item.ini:
        ini = item.ini
        del item.ini
    else:
        ini = 0

    for k in sorted(listado.keys())[ini:ini + 40]:
        itemlist.append(item.clone(
            tvshowtitle=k,
            title = k,
            temporadas=listado[k],
            type='tvshow',
            content_type='seasons',
            action='seasons'
        ))

    # paginacion
    if ini + 40 < len(listado):
        itemlist.append(item.clone(
            ini=ini + 40,
            type='next'))

    return itemlist


def listado_unico_peliculas(item):
    logger.trace()

    post = {
        'submit': 'Buscar',
        'campo': item.campo,
        'valor2': item.valor,
        'valor3': item.valor
    }

    data = httptools.downloadpage(item.url, post=post).data
    data = scrapertools.find_single_match(data, '<br>Se han encontrado <b>(.*?)</table><br></td>')
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    return filtrar_peliculas(item, scrapertools.find_multiple_matches(data, "<td><a href='([^']+)'.*?>\s?([^<]+)</a>"))


def filtrar_peliculas(item, peliculas):
    logger.trace()
    itemlist = list()
    listado = dict()

    for url, title in peliculas:
        title = re.sub(r'\s?\.?\s?$', '', re.sub(r'[\(|\[].*[\)|\]]', '', title))
        listado_urls = listado.get(title, [])
        listado_urls.append(HOST + url)
        listado[title] = listado_urls

    ini = item.ini if item.ini else 0

    for k in sorted(listado.keys())[ini:ini + 40]:
        itemlist.append(item.clone(
            title=k,
            url=listado[k],
            type='movie',
            content_type='servers',
            action='findvideos'
        ))

    # paginacion
    if ini + 40 < len(listado):
        itemlist.append(item.clone(
            ini=ini + 40,
            type='next'))

    return itemlist


def newest_movies(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    # Extraemos bloque_noticia
    patron = "<td><div align='justify'><center>(.*?)</td>"
    for noticia in scrapertools.find_multiple_matches(data,patron):
        # Obtenemos las urls y los posters incluidos en cada noticia
        patron = '<a href="([^"]+)"><img src="([^"]+)'
        for url, poster in scrapertools.find_multiple_matches(noticia, patron):
            # Con ayuda de la url obtenemos el titulo y la calidad de cada pelicula
            patron = '%s">([^<]+)</a>\s*<b>([^<]+)</b>' % url

            title, quality = scrapertools.find_single_match(noticia, patron)
            quality = quality.replace('(', '').replace(')', '').strip()
            title = re.sub(r'\s?\.?\s?$', '', re.sub('[\(|\[]%s[\)|\]]' % quality, '', title))

            itemlist.append(item.clone(
                title=title,
                label=title,
                url= HOST + url,
                type="movie",
                content_type="servers",
                poster= HOST + poster.replace(' ', '%20'),
                action="findvideos",
                quality=QLT.get(quality)
                ))

    # Paginador
    if len(itemlist) > 40:
        if not item.page:
            itemlist = itemlist[:len(itemlist) / 2]
            next_url = ""
            itemlist.append(item.clone(
                type='next',
                page=True
            ))
        else:
            itemlist = itemlist[len(itemlist) / 2:]
            next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    else:
        next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    if next_url:
        next_url = HOST + next_url
        itemlist.append(item.clone(
            url=next_url,
            type='next',
            page=False
        ))

    return itemlist


def newest_episodes(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    # Extraemos bloque_noticia
    patron = "<td><div align='justify'><center>(.*?)</td>"
    for noticia in scrapertools.find_multiple_matches(data, patron):
        # Obtenemos las urls y los posters incluidos en cada noticia
        patron = '<a href="([^"]+)"><img src="([^"]+)'
        for url, poster in scrapertools.find_multiple_matches(noticia, patron):
            # Con ayuda de la url obtenemos el titulo_temporada y el capitulo
            patron = '%s">([^<]+)</a>\s*<b>([^<]+)</b>' % url
            title_season, episode = scrapertools.find_single_match(noticia, patron)
            tvshowtitle, season = scrapertools.find_single_match(title_season, "(?i)(.*?) - ([0-9,M]+)")
            quality = scrapertools.find_single_match(title_season, "\[([^\]]+)")

            # si es miniserie
            season = int(season.lower().replace('m', '1'))

            new_item = item.clone(
                tvshowtitle=tvshowtitle.strip(),
                label=tvshowtitle.strip(),
                url=HOST + url,
                action="findvideos",
                thumb=HOST + poster.replace(' ', '%20'),
                season=season,
                type='episode',
                content_type='servers',
                quality = QLT.get(quality) if quality else item.quality
            )

            num_episode = scrapertools.find_multiple_matches(episode, "(\d+)")
            num_episode = [int(n) for n in num_episode]
            new_item.episode = num_episode[0]

            if len(num_episode) > 1:
                if 'al' in episode and len(num_episode) == 2:
                    multi_episodes = range(num_episode[0], num_episode[1] + 1)
                else:
                    multi_episodes = num_episode

                if 'serie-episodio-descargar-torrent' in url or 'serie-descargar-torrents' in url:
                    new_item.multi_episodes = multi_episodes


            if 'serie-descargar-torrents' in url:
                new_item.content_type = 'episodes'
                new_item.action='filter_episodes' # Esto obtiene solo los episodios indicados

            itemlist.append(new_item)

    # Paginador
    if len(itemlist) > 40:
        if not item.page:
            itemlist = itemlist[:len(itemlist) / 2]
            next_url = ""
            itemlist.append(item.clone(
                type='next',
                page=True
            ))
        else:
            itemlist = itemlist[len(itemlist) / 2:]
            next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    else:
        next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    if next_url:
        next_url = HOST + next_url
        itemlist.append(item.clone(
            url=next_url,
            type='next',
            page=False
        ))

    return itemlist


def filter_episodes(item):
    itemlist= list()

    if item.multi_episodes:
        multi_episodes = item.multi_episodes
        item.multi_episodes=[]

        for new_item in episodes(item):
            if new_item.multi_episodes:
                # Verdadero multi_episodes
                if set(multi_episodes).intersection(set(new_item.multi_episodes)):
                    itemlist.append(new_item)
            elif new_item.episode in multi_episodes:
                itemlist.append(new_item)
    else:
        for new_item in episodes(item):
            if new_item.episode == item.episode:
                itemlist = findvideos(new_item)
                break

    return itemlist


def seasons(item):
    logger.trace()
    itemlist = list()

    for s in  sorted(item.temporadas.keys()):
        itemlist.append(item.clone(
            action="episodes",
            season=s,
            type='season',
            url= item.temporadas[s],
            content_type='episodes'
        ))

    return itemlist


def episodes(item):
    logger.trace()
    itemlist = list()
    listado = {}

    if not isinstance(item.url, list):
        item.url = [item.url]

    for url in item.url:
        data = httptools.downloadpage(url).data
        data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
        data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

        patron = "<a href='(/serie-episodio-descargar-torrent[^']+)'>([^<]+)"
        for url, episode in scrapertools.find_multiple_matches(data, patron):
            num_episode = scrapertools.find_multiple_matches(episode, "\d+x(\d+)")
            if len(num_episode) == 1:
                n = int(num_episode[0])
                listado_urls = listado.get(n, [])
                listado_urls.append(HOST + url)
                listado[n] = listado_urls

            else:
                if 'al' in episode and len(num_episode) == 2:
                    multi_episodes = range(int(num_episode[0]), int(num_episode[1]) + 1)
                else:
                    multi_episodes = [int(n) for n in num_episode].sorted()

                for n in multi_episodes:
                    listado_urls = listado.get(n, [])
                    listado_urls.append(HOST + url)
                    listado[n] = listado_urls

    if listado:
        if item.ini:
            ini = item.ini
            del item.ini
        else:
            ini = 0

        for k in sorted(listado.keys())[ini:ini + 40]:
            itemlist.append(item.clone(
                url=listado[k],
                episode=k,
                action="findvideos",
                type='episode',
                content_type='servers'
            ))

        # paginacion
        if ini + 40 < len(listado):
            itemlist.append(item.clone(
                ini=ini + 40,
                type='next'))


    return itemlist


def findvideos(item):
    logger.trace()
    itemlist = list()

    if not isinstance(item.url, list):
        item.url = [item.url]

    for url in item.url:
        data = httptools.downloadpage(url).data
        data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
        data = re.sub(r"\n|\r|\t|&nbsp;|<br>", "", data)

        patron = "<img border=.*?src='([^']+).*?<b>Formato:?</b>:?\s*([^<]+).*?<b>Torrent.*?href='([^']+)"
        poster, quality, url = scrapertools.find_single_match(data,patron)

        table_name = scrapertools.find_single_match(httptools.downloadpage(HOST + "/" + url).data, "Pincha <a href='.*?table=([^/]+)/&name=([^']+)")
        if table_name:
            new_item = item.clone(
                action="play",
                url='%s/uploads/torrents/%s/%s' % (HOST, table_name[0], table_name[1]),
                quality=QLT.get(quality),
                poster=item.poster if item.poster.startswith(HOST) else poster.replace(' ', '%20'),
                type='server',
                server='torrent'
            )

            size = scrapertools.find_single_match(data, 'Tamaño:</b>(.*?)<').replace(',', '.')
            if size:
                n = float(scrapertools.find_single_match(size, '(\d[.\d]*)')) * 1024
                new_item.size = n * 1024 if 'gb' in size.lower() else n


            itemlist.append(new_item)

    return servertools.get_servers_from_id(itemlist)

