# -*- coding: utf-8 -*-
import socket
import threading
from functools import wraps

import HTTPServer
import WebSocket
from core.libs import *


def get_public_ip():
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.connect(('8.8.8.8', 53))
    return s.getsockname()[0]


def thread_name(func):
    @wraps(func)
    def bar(*args, **kw):
        if "name" not in kw:
            kw['name'] = threading.current_thread().name
        return func(*args, **kw)

    return bar


http_port = settings.get_setting("http_port", platformsettings.__file__)
websocket_port = settings.get_setting("websocket_port", platformsettings.__file__)
threading.Thread.__init__ = thread_name(threading.Thread.__init__)
myip = get_public_ip()


def print_status():
    os.system('cls' if os.name == 'nt' else 'clear')
    print ('--------------------------------------------------------------------')
    print ('MediaExplorer Iniciado')
    print ('La URL para acceder es http://%s:%s' % (myip, http_port))
    print ('WebSocket Server iniciado en ws://%s:%s' % (myip, websocket_port))
    print ('--------------------------------------------------------------------')
    print ('Runtime Path      : ' + sysinfo.runtime_path)
    print ('Data Path         : ' + sysinfo.data_path)
    print ('--------------------------------------------------------------------')


def start():
    logger.debug('MediaExplorer server init...')

    try:
        HTTPServer.start()
        WebSocket.start()

        # Da por levantado el servicio
        logger.debug('--------------------------------------------------------------------')
        logger.debug('MediaExplorer Iniciado')
        logger.debug('La URL para acceder es http://%s:%s' % (myip, http_port))
        logger.debug('WebSocket Server iniciado en ws://%s:%s' % (myip, websocket_port))
        logger.debug('--------------------------------------------------------------------')
        logger.debug('Runtime Path      : ' + sysinfo.runtime_path)
        logger.debug('Data Path         : ' + sysinfo.data_path)
        logger.debug('--------------------------------------------------------------------')
        print_status()

        running = True
        while running:
            time.sleep(1)

    except KeyboardInterrupt:
        print 'Deteniendo el servidor HTTP...'
        HTTPServer.stop()
        print 'Deteniendo el servidor WebSocket...'
        WebSocket.stop()
        print 'MediaExplorer Detenido'


# Inicia MediaExplorer
start()
