function Loading_hide() {
    var el = document.getElementById("loading");
    if (el) {
        el.parentNode.removeChild(el);
    }
}

function Loading_show() {
    Loading_hide();
    var el = document.createElement("div");
    el.className = "loading";
    el.id = "loading";
    el.appendChild(document.createElement("div"));
    document.getElementsByTagName("body")[0].appendChild(el);
}

function Dialog_notification(response) {
    var el = document.createElement("div");
    el.className = "notification";
    el.id = response.id;
    el.innerHTML = html.dialog_notification;
    el.getElementById("icon").className = "icon" + response.icon;
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("title").setValue(response.heading);
    el.getElementById("content").setValue(response.message);
    var time = parseFloat(response.time);
    setTimeout(function () {
        el.parentNode.removeChild(el);
    }, time);
    if (response.sound) {
        var audio = new Audio("/media/notification.wav");
        audio.play();
    }
}

function Dialog_select(response) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.innerHTML = html.dialog_select;
    el.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": -1
        });
        el.parentNode.removeChild(el);
    };
    var x;
    for (x in response.list) {
        var a = document.createElement("a");
        a.setValue(response.list[x]);
        a.href = "javascript:void(0)";
        a.id = x;
        a.onclick = function () {
            send_data({
                "id": response.id,
                "result": parseInt(this.id)
            });
            el.parentNode.removeChild(el);
        };
        el.getElementById("content").appendChild(a);
    }
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("content").children[0].focus();
    el.getElementById("title").setValue(response.heading);
}
Dialog_ok = function (response) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.innerHTML = html.dialog_ok;
    var message = response.line1.replace(/\n/g, "<br/>");
    if (response.line2) {
        message += "</br>" + response.line2.replace(/\n/g, "<br/>");
    }
    if (response.line3) {
        message += "</br>" + response.line3.replace(/\n/g, "<br/>");
    }
    el.getElementById("ok").onclick = function () {
        send_data({
            "id": response.id,
            "result": true
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": true
        });
        el.parentNode.removeChild(el);
    };
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("title").setValue(response.heading);
    el.getElementById("content").setValue(message);
    el.getElementById("ok").focus();
};

function Dialog_yesno(response) {
    function autoclose(id) {
        var el = document.getElementById(id);
        if (el) {
            send_data({
                "id": id,
                "result": false
            });
            el.parentNode.removeChild(el);
        }
    }
    var el$$0 = document.createElement("div");
    el$$0.className = "overlay";
    el$$0.id = response.id;
    el$$0.innerHTML = html.dialog_yesno;
    var message = response.line1.replace(/\n/g, "<br/>");
    if (response.line2) {
        message += "</br>" + response.line2.replace(/\n/g, "<br/>");
    }
    if (response.line3) {
        message += "</br>" + response.line3.replace(/\n/g, "<br/>");
    }
    el$$0.getElementById("yes").innerText = response.yeslabel;
    el$$0.getElementById("yes").onclick = function () {
        send_data({
            "id": response.id,
            "result": true
        });
        el$$0.parentNode.removeChild(el$$0);
    };
    el$$0.getElementById("no").innerText = response.nolabel;
    el$$0.getElementById("no").onclick = function () {
        send_data({
            "id": response.id,
            "result": false
        });
        el$$0.parentNode.removeChild(el$$0);
    };
    el$$0.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": false
        });
        el$$0.parentNode.removeChild(el$$0);
    };
    document.getElementsByTagName("body")[0].appendChild(el$$0);
    el$$0.getElementById("title").setValue(response.heading);
    el$$0.getElementById("content").setValue(message);
    el$$0.getElementById("no").focus();
    if (response.autoclose) {
        time = parseFloat(response.autoclose) * 1E3;
        setTimeout(autoclose, time, response.id);
    }
}

function Dialog_img_yesno(response) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.innerHTML = html.dialog_img_yesno;
    el.getElementById("img").src = response.img;
    el.getElementById("yes").innerText = response.yeslabel;
    el.getElementById("yes").onclick = function () {
        send_data({
            "id": response.id,
            "result": true
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("no").innerText = response.nolabel;
    el.getElementById("no").onclick = function () {
        send_data({
            "id": response.id,
            "result": false
        });
        el.parentNode.removeChild(el);
    };
    if (!response.noshow) {
        el.getElementById("no").style.display = "none";
    }else{
        el.getElementById("no").style.display = "";
    }
    el.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": false
        });
        el.parentNode.removeChild(el);
    };
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("title").setValue(response.heading);
    el.getElementById("content").setValue(response.message.replace(/\n/g, "<br/>"));
    el.getElementById("yes").focus();
}

function Dialog_info(response) {
    if (response.dialog_id) {
        var el = document.getElementById(response.dialog_id);
        var id = response.dialog_id;
    }
    else {
        id = response.id;
        el = document.createElement("div");
        el.className = "overlay";
        el.id = response.id;
        el.innerHTML = html.dialog_info;
        el.getElementById("title").innerHTML = response.heading;
        el.getElementById("close").onclick = function () {
            send_data({
                "id": id,
                "result": {
                    "action": "close"
                }
            });
            el.parentNode.removeChild(el);
        };
        el.getElementById("ok").onclick = function () {
            send_data({
                "id": id,
                "result": {
                    "action": "ok"
                }
            });
            el.parentNode.removeChild(el);
        };
        el.getElementById("cancel").onclick = function () {
            send_data({
                "id": id,
                "result": {
                    "action": "close"
                }
            });
            el.parentNode.removeChild(el);
        };
    }
    if (response.count == 1) {
        el.getElementById("buttons").style.display = "none";
    }
    else {
        if (response.index == 0) {
            el.getElementById("previous").onclick = null;
            el.getElementById("previous").classList.add("disabled");
        }
        else {
            el.getElementById("previous").onclick = function () {
                send_data({
                    "id": id,
                    "result": {
                        "action": "previous"
                    }
                });
            };
            el.getElementById("previous").classList.remove("disabled");
        }
        if (response.index == response.count - 1) {
            el.getElementById("next").onclick = null;
            el.getElementById("next").classList.add("disabled");
        }
        else {
            el.getElementById("next").onclick = function () {
                send_data({
                    "id": id,
                    "result": {
                        "action": "next"
                    }
                });
            };
            el.getElementById("next").classList.remove("disabled");
        }
        el.getElementById("count").innerText = "(" + (response.index + 1) + " de " + response.count + ")";
    }
    el.getElementById("poster").style.backgroundImage = "url(" + response.item.poster + ")";
    el.getElementById("fanart").style.backgroundImage = "linear-gradient(rgba(255,255,255,.5), rgba(255,255,255,.5)), url(" + response.item.fanart + ")";
    document.getElementsByTagName("body")[0].appendChild(el);
    switch (response.item.type) {
    case "channel":
        el.getElementById("head1").innerText = "Nombre:";
        el.getElementById("line1").innerText = response.item.name;
        el.getElementById("head2").innerText = "Versión:";
        el.getElementById("line2").innerText = response.item.version || "N/A";
        el.getElementById("head3").innerText = "Contenido adultos:";
        el.getElementById("line3").innerText = response.item.adult ? "Si" : "No";
        el.getElementById("head4").innerText = "Categorias:";
        el.getElementById("line4").innerText = response.item.categories.join(", ") || "N/A";
        el.getElementById("head5").innerText = "Búsqueda global:";
        el.getElementById("line5").innerText = response.item.search.join(", ") || "No";
        el.getElementById("head6").innerText = "Novedades:";
        el.getElementById("line6").innerText = response.item.newest.join(", ") || "No";
        if (response.item.min_version.length) {
            el.getElementById("head7").innerText = "Requisitos:";
            el.getElementById("line7").innerText = response.item.min_version.join(", ");
        }
        el.getElementById("head9").innerText = "Cambios:";
        el.getElementById("line9").innerText = response.item.changes.join("<br/>");
        break;
    case "movie":
        el.getElementById("head1").innerText = "Titulo:";
        el.getElementById("line1").innerText = response.item.title;
        el.getElementById("head2").innerText = "Titulo original:";
        el.getElementById("line2").innerText = response.item.originaltitle || "N/A";
        el.getElementById("head3").innerText = "Idioma original:";
        el.getElementById("line3").innerText = response.item.language || "N/A";
        el.getElementById("head4").innerText = "Puntuación:";
        el.getElementById("line4").innerText = response.item.rating || "N/A" + "(" + (response.item.votes || "N/A") + ")";
        el.getElementById("head5").innerText = "Lanzamiento:";
        el.getElementById("line5").innerText = response.item.year || "N/A";
        el.getElementById("head6").innerText = "Generos:";
        el.getElementById("line6").innerText = response.item.genre || "N/A";
        el.getElementById("head9").innerText = "Sinopsis:";
        el.getElementById("line9").setValue(response.item.plot || "");
        break;
    case "tvshow":
        el.getElementById("head1").innerText = "Serie:";
        el.getElementById("line1").innerText = response.item.tvshowtitle || response.item.title;
        el.getElementById("head2").innerText = "Idioma original:";
        el.getElementById("line2").innerText = response.item.language || "N/A";
        el.getElementById("head3").innerText = "Puntuación:";
        el.getElementById("line3").innerText = response.item.rating || "N/A" + "(" + (response.item.votes || "N/A") + ")";
        el.getElementById("head4").innerText = "Generos:";
        el.getElementById("line4").innerText = response.item.genre || "N/A";
        el.getElementById("head9").innerText = "Sinopsis:";
        el.getElementById("line9").setValue(response.item.plot || "");
        break;
    case "season":
        el.getElementById("head1").innerText = "Serie:";
        el.getElementById("line1").innerText = response.item.tvshowtitle;
        el.getElementById("head2").innerText = "Idioma original:";
        el.getElementById("line2").innerText = response.item.language || "N/A";
        el.getElementById("head3").innerText = "Puntuación:";
        el.getElementById("line3").innerText = response.item.rating || "N/A" + "(" + (response.item.votes || "N/A") + ")";
        el.getElementById("head4").innerText = "Generos:";
        el.getElementById("line4").innerText = response.item.genre || "N/A";
        el.getElementById("head5").innerText = "Título temporada:";
        el.getElementById("line5").innerText = response.item.title || "N/A";
        el.getElementById("head6").innerText = "Temporada:";
        el.getElementById("line6").innerText = response.item.season || "N/A";
        el.getElementById("head9").innerText = "Sinopsis:";
        el.getElementById("line9").setValue(response.item.plot || "");
        break;
    case "episode":
        el.getElementById("head1").innerText = "Serie:";
        el.getElementById("line1").innerText = response.item.tvshowtitle;
        el.getElementById("head2").innerText = "Idioma original:";
        el.getElementById("line2").innerText = response.item.language || "N/A";
        el.getElementById("head3").innerText = "Puntuación:";
        el.getElementById("line3").innerText = response.item.rating || "N/A" + "(" + (response.item.votes || "N/A") + ")";
        el.getElementById("head4").innerText = "Generos:";
        el.getElementById("line4").innerText = response.item.genre || "N/A";
        el.getElementById("head5").innerText = "Título:";
        el.getElementById("line5").innerText = response.item.title || "N/A";
        el.getElementById("head6").innerText = "Temporada:";
        el.getElementById("line6").innerText = response.item.season || ("N/A" + " de " + response.item.seasons || "N/A");
        el.getElementById("head7").innerText = "Episodio:";
        el.getElementById("line7").innerText = response.item.episode || ("N/A" + " de " + response.item.episodes || "N/A");
        el.getElementById("head8").innerText = "Emisión:";
        el.getElementById("line8").innerText = response.item.aired || "N/A";
        el.getElementById("head9").innerText = "Sinopsis:";
        el.getElementById("line9").setValue(response.item.plot || "");
        break;
    }

    el.getElementById("close").focus();
}
function Dialog_firstrun(response) {
    if (response.dialog_id) {
        var el = document.getElementById(response.dialog_id);
        var id = response.dialog_id;
    }
    else {
        id = response.id;
        el = document.createElement("div");
        el.className = "overlay";
        el.id = response.id;
        el.innerHTML = html.dialog_firstrun;
        el.getElementById("title").innerHTML = '';
        el.getElementById("button1").onclick = function () {
            send_data({
                "id": id,
                "result": {
                    "action": "button1"
                }
            });
        };
        el.getElementById("button2").onclick = function () {
            send_data({
                "id": id,
                "result": {
                    "action": "button2"
                }
            });
        };
        el.getElementById("button3").onclick = function () {
            send_data({
                "id": id,
                "result": {
                    "action": "button3"
                }
            });
        };

        document.getElementsByTagName("body")[0].appendChild(el);
    }

    el.getElementById("label").innerHTML = response.label;
    el.getElementById("text").innerHTML = response.text;

    if (!response.button1){
        el.getElementById("button1").style.display  = 'none';
        el.getElementById("button1").innerHTML  = '';
    } else {
        el.getElementById("button1").style.display  = 'inline-block';
        el.getElementById("button1").innerHTML  = response.button1;
    }
    if (!response.button2){
        el.getElementById("button2").style.display = 'none';
        el.getElementById("button2").innerHTML  = '';
    } else {
        el.getElementById("button2").style.display = 'inline-block';
        el.getElementById("button2").innerHTML = response.button2;
    }
    if (!response.button3){
        el.getElementById("button3").style.display = 'none';
        el.getElementById("button3").innerHTML = '';
    } else {
        el.getElementById("button3").style.display = 'inline-block';
        el.getElementById("button3").innerHTML = response.button3;
    }
    el.getElementById(response.focus).focus();
}
Dialog_captcha = function (response) {
    function autoclose() {
        var el = document.getElementById("dialog_yesno");
        if (el) {
            send_data({
                "id": id,
                "result": false
            });
            el.parentNode.removeChild(el);
        }
    }
    var el$$0 = document.createElement("div");
    el$$0.className = "overlay";
    el$$0.id = response.id;
    el$$0.innerHTML = html.dialog_captcha;
    el$$0.getElementById("title").innerHTML = "Captcha";
    el$$0.getElementById("image").style.backgroundImage = "url(" + response.path + ")";
    el$$0.getElementById("ok").onclick = function () {
        send_data({
            "id": response.id,
            "result": el$$0.getElementById("text").value
        });
        el$$0.parentNode.removeChild(el$$0);
    };
    el$$0.getElementById("cancel").onclick = function () {
        send_data({
            "id": response.id,
            "result": null
        });
        el$$0.parentNode.removeChild(el$$0);
    };
    el$$0.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": null
        });
        el$$0.parentNode.removeChild(el$$0);
    };
    document.getElementsByTagName("body")[0].appendChild(el$$0);
    el$$0.getElementById("ok").focus();
    if (response.autoclose) {
        time = parseFloat(data.autoclose) * 1E3;
        setTimeout(autoclose, time);
    }
};

function Dialog_input(response) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.innerHTML = html.dialog_input;
    el.getElementById("title").innerHTML = response.heading;
    el.getElementById("text").value = response["default"];
    el.getElementById("text").type = response.hidden ? "password" : "text";
    el.getElementById("ok").onclick = function () {
        send_data({
            "id": response.id,
            "result": el.getElementById("text").value
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("cancel").onclick = function () {
        send_data({
            "id": response.id,
            "result": null
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": null
        });
        el.parentNode.removeChild(el);
    };
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("text").focus();
}

function Dialog_numeric(response) {
    response.type = response.type ? response.type : 0;
    if (data.type == 0) {
        type = "number";
    }
    if (data.type == 1) {
        type = "date";
    }
    if (data.type == 2) {
        type = "time";
    }
    if (data.type == 3) {
        type = "ip";
    }
    type = "text";
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.innerHTML = html.dialog_input;
    el.getElementById("title").innerHTML = response.heading;
    el.getElementById("text").value = response["default"];
    el.getElementById("text").type = response - type;
    el.getElementById("ok").onclick = function () {
        send_data({
            "id": response.id,
            "result": el.getElementById("text").value
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("cancel").onclick = function () {
        send_data({
            "id": response.id,
            "result": null
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": null
        });
        el.parentNode.removeChild(el);
    };
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("text").focus();
}

function Dialog_progress_bg(response) {
    var el = document.createElement("div");
    el.className = "progress";
    el.id = response.id;
    el.innerHTML = html.dialog_progress_bg;
    el.getElementById("title").innerHTML = response.heading;
    el.getElementById("content").innerHTML = response.message;
    el.getElementById("percent").innerText = "0%";
    document.getElementsByTagName("body")[0].appendChild(el);
}

function Dialog_progress(response) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.innerHTML = html.dialog_progress;
    el.getElementById("title").innerHTML = response.heading;
    var message = response.line1.replace(/\n/g, "<br/>");
    if (response.line2) {
        message += "</br>" + response.line2.replace(/\n/g, "<br/>");
    }
    if (response.line3) {
        message += "</br>" + response.line3.replace(/\n/g, "<br/>");
    }
    el.getElementById("content").innerHTML = message;
    el.getElementById("percent").style.width = "0%";
    el.getElementById("cancel").onclick = function () {
        el.canceled = true;
        el.getElementById("title").innerHTML += " Cancelando...";
    };
    el.getElementById("close").onclick = function () {
        el.canceled = true;
        el.getElementById("title").innerHTML += " Cancelando...";
    };
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("cancel").focus();
}

function Dialog_settings(response) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = response.id;
    el.callback = response.callback;
    el.custom_button = response.custom_button;
    el.module = response.module;
    el.controls = response.controls;
    el.innerHTML = html.dialog_settings;
    el.init_values = {};
    el.getElementById("title").innerHTML = response.title;
    var x;
    for (x in response.controls) {
        response.controls[x].id = response.controls[x].id ? btoa(response.controls[x].id) : btoa("und" + Math.floor(Math.random() * 167772158859).toString(16));
        a = document.createElement("a");
        a.id = response.controls[x].id;
        a.innerHTML = response.controls[x].label;
        a.className = response.controls[x].type;
        a.style.color = response.controls[x].color;
        var label = null;
        var ctrl = null;
        switch (response.controls[x].type) {
        case "list":
            ctrl = document.createElement("select");
            ctrl.id = response.controls[x].id;
            ctrl.mode = response.controls[x].mode
            for (y in response.controls[x].lvalues) {
                opt = document.createElement("option");
                opt.value = y;
                opt.text = response.controls[x].lvalues[y];
                ctrl.appendChild(opt);
            }
            if (response.controls[x].mode == 'label' && typeof response.controls[x].value == "string"){
                if (response.controls[x].values){
                    ctrl.value = response.controls[x].values.indexOf(response.controls[x].value);
                }else {
                    ctrl.value = response.controls[x].lvalues.indexOf(response.controls[x].value);
                }
            }else {
                ctrl.value = response.controls[x].value
            }

            el.init_values[ctrl.id] = ctrl.value;
            label = document.createElement("div");
            label.className = "settings_list";
            label.appendChild(ctrl);
            label.appendChild(document.createElement("i"));
            break;
        case "text":
            ctrl = document.createElement("input");
            ctrl.type = response.controls[x].hidden ? "password" : "text";
            ctrl.id = response.controls[x].id;
            ctrl.value = response.controls[x].value;
            el.init_values[ctrl.id] = ctrl.value;
            label = document.createElement("div");
            label.className = "settings_text";
            label.appendChild(ctrl);
            break;
        case "file":
            ctrl = document.createElement("input");
            ctrl.type = "text";
            ctrl.id = response.controls[x].id;
            ctrl.value = response.controls[x].value;
            el.init_values[ctrl.id] = ctrl.value;
            label = document.createElement("div");
            label.className = "settings_text";
            label.appendChild(ctrl);
            break;
        case "folder":
            ctrl = document.createElement("input");
            ctrl.type = "text";
            ctrl.id = response.controls[x].id;
            ctrl.value = response.controls[x].value;
            el.init_values[ctrl.id] = ctrl.value;
            label = document.createElement("div");
            label.className = "settings_text";
            label.appendChild(ctrl);
            break;
        case "bool":
            ctrl = document.createElement("input");
            ctrl.type = "checkbox";
            ctrl.id = response.controls[x].id;
            ctrl.checked = response.controls[x].value;
            el.init_values[ctrl.id] = ctrl.value;
            label = document.createElement("div");
            label.className = "settings_bool";
            label.appendChild(ctrl);
            label.appendChild(document.createElement("i"));
            break;
        case "label":
            break;
        }
        if (ctrl) {
            ctrl.onchange = function () {
                evaluate_controls(el, this);
            };
            ctrl.onfocus = function () {
                this.getParentByTagName("a").classList.add("focus");
            };
            ctrl.onblur = function () {
                this.getParentByTagName("a").classList.remove("focus");
            };
        }
        if (label) {
            a.appendChild(label);
        }
        el.getElementById("content").appendChild(a);
    }
    el.getElementById("close").onclick = function () {
        send_data({
            "id": response.id,
            "result": {
                "action": "close"
            }
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("ok").onclick = function () {
        send_data({
            "id": response.id,
            "result": {
                "action": "ok",
                "values": el.controls
            }
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("cancel").onclick = function () {
        send_data({
            "id": response.id,
            "result": {
                "action": "close"
            }
        });
        el.parentNode.removeChild(el);
    };
    el.getElementById("default").onclick = function () {
        default_values(el);
    };
    check_custom_button(el);
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("cancel").focus();
    evaluate_controls(el);
}

function Dialog_web_settings() {
    var id = "web_settings";
    var controls = [{
        "type": "label",
        "label": "Navegación:"
    }, {
        "type": "bool",
        "label": "Usar navegación del explorador",
        "id": "builtin_history",
        "value": settings.builtin_history,
        "default": false
    }, {
        "type": "label",
        "label": "Visualización:"
    }, {
        "type": "bool",
        "label": "Mostrar Fanarts",
        "id": "show_fanart",
        "value": settings.show_fanart,
        "default": true
    }, {
        "type": "label",
        "label": "Método de acceso al contenido multimedia:"
    }, {
        "type": "list",
        "label": "Imagenes",
        "id": "image_mode",
        "value": settings.image_mode,
        "default": 0,
        "lvalues": ["Automatico", "Directo", "Indirecto"]
    }, {
        "type": "list",
        "label": "Vídeos",
        "id": "play_mode",
        "value": settings.play_mode,
        "default": 0,
        "lvalues": ["Preguntar", "Directo", "Indirecto"]
    }, {
        "type": "label",
        "label": "Reproducción:"
    }, {
        "type": "list",
        "label": "Reproductor",
        "id": "player_mode",
        "value": settings.player_mode,
        "default": 0,
        "lvalues": ["Preguntar"].concat(Object.values(players))
    }];
    Dialog_settings({
        "id": "web_settings",
        "title": "Ajustes de la interfaz",
        "controls": controls
    });
    var el = document.getElementById("web_settings");
    el.getElementById("close").onclick = function () {
        el.parentNode.removeChild(el);
    };
    el.getElementById("ok").onclick = function () {
        save_settings(el);
        el.parentNode.removeChild(el);
    };
    el.getElementById("cancel").onclick = function () {
        el.parentNode.removeChild(el);
    };
};
