var debugmode = true;

window.onerror = function (msg, url, lineNo, columnNo, error) {
    if (this.debugmode){
        document.getElementById('debug').style.display = 'block'
        document.getElementById('debug').innerHTML = 'Se ha producido un error:'
        document.getElementById('debug').innerHTML += url + '<br/>'
        document.getElementById('debug').innerHTML += 'linea: ' + lineNo + ' columna: ' + columnNo + '<br/>'
        document.getElementById('debug').innerHTML += error + '<br/>'
        document.getElementById('debug').innerHTML += msg
        setTimeout(hide_error, 5000)
    }
    try{
        send_action({type: 'error', msg:msg, url:url, lineNo:lineNo, columnNo:columnNo, error:error})
    } catch{e}{
    }
}

function hide_error(){
    document.getElementById('debug').style.display = 'none'
    document.getElementById('debug').innerHTML = ''
}

Object.defineProperty(document, 'activeElement', {
  get: function() {
    elm = document.querySelector(":focus");
    return elm.getParentByTagName('a')
    }
});

HTMLElement.prototype.setValue = function (value) {
    var el = this;
    el.innerHTML = value;
    if (el.tagName == "A") {
        el.onfocus = function () {
            autoscroll(this);
        };
        el.onblur = function () {
            clearInterval(this.scroll);
            this.scrollTop = 0;
            this.scrollLeft = 0;
        };
    }
    else {
        if (el.id == "label") {
            var a = el.getParentByTagName("a");
            if (a) {
                a.onfocus = function () {
                    document.getElementById("items").fitem = this;
                    show_item_info(this);
                    autoscroll(this.getElementById("label"));
                };
                a.onblur = function () {
                    clearInterval(this.getElementById("label").scroll);
                    this.getElementById("label").scrollTop = 0;
                    this.getElementById("label").scrollLeft = 0;
                };
            }
        }
        else {
            autoscroll(el);
        }
    }
};


function autoscroll(el) {
    clearInterval(el.scroll);
    el.scrollLeft = 0;
    el.scrollTop = 0;
    if (el.scrollWidth > el.offsetWidth + 1) {
        initialscrollWidth = el.scrollWidth;
        el.innerHTML = el.innerHTML + " | " + el.innerHTML;
        el.scroll = setInterval(function () {
            if (!el.scrollWidth) {
                clearInterval(el.scroll);
            }
            el.scrollLeft += 1;
            if (el.scrollLeft - 1 >= el.scrollWidth - initialscrollWidth) {
                el.scrollLeft = 0;
            }
        }, 80);
    }
    if (el.scrollHeight > el.offsetHeight + 1) {
        initialscrollHeight = el.scrollHeight;
        el.innerHTML = el.innerHTML + "</br>" + el.innerHTML;
        el.scroll = setInterval(function () {
            if (!el.scrollHeight) {
                clearInterval(el.scroll);
            }
            el.scrollTop += 1;
            if (el.scrollTop >= el.scrollHeight - initialscrollHeight) {
                el.scrollTop = 0;
            }
        }, 80);
    }
};

HTMLElement.prototype.getParentByTagName = function (tag) {
    var el = this;
    for (; el && el.tagName != tag.toUpperCase();) {
        el = el.parentNode;
    }
    return el;
};
HTMLElement.prototype.getElementById = function (id) {
    var x = 0;
    for (; x < this.children.length; x++) {
        if (this.children[x].id == id) {
            return this.children[x];
        }
    }
    x = 0;
    for (; x < this.children.length; x++) {
        result = this.children[x].getElementById(id);
        if (result != null) {
            return result;
        }
    }
    return null;
};
Object.defineProperty(Array.prototype, "all", {
    enumerable: false,
    value: function () {
        var list = this;
        unique = list.filter(function (item, pos) {
            return list.indexOf(item) == pos;
        });
        return unique.length == 1 && Boolean(unique[0]);
    }
});
Object.defineProperty(Array.prototype, "unique", {
    enumerable: false,
    value: function (val) {
        var list = this;
        res = list.filter(function (item, pos) {
            return list.indexOf(item) == pos;
        });
        if (arguments) {
            val = arguments[0];
            return res.length == 1 && res[0] == val;
        }
        return res;
    }
});
Object.defineProperty(Array.prototype, "key", {
    enumerable: false,
    value: function (key) {
        var res = [];
        var x;
        for (x in this) {
            res.push(this[x][key]);
        }
        return res;
    }
});
if (!Object.values){
	Object.defineProperty(Object.prototype, "values", {
		enumerable: false,
		value: function(){return Object.keys(this).map(function(e){return obj[e]})}
	});
}

document.onmouseover = function (e) {
    var el = e.target.getParentByTagName("a");
    if (el) {
        el.focus();
    }
};
document.onmouseout = function (e) {
    var el = e.target.getParentByTagName("a");
    if (e.relatedTarget) {
        var other = e.relatedTarget.getParentByTagName("a")
    }
    else {
        other = null;
    }
    if (el && el != other) {
        el.blur();
    }
};
document.getNavigableObjects = function () {
    var el = document.getElementsByTagName("*");
    var list = [];
    var x = 0;
    for (; x < el.length; x++) {
        if (el[x].className == "overlay") {
            list = [];
        }
        if (el[x].tagName == "A" && el[x].href) {
            list.push(el[x]);
        }
        if (el[x].tagName == "INPUT" && !el[x].disabled) {
            list.push(el[x]);
        }
        if (el[x].tagName == "SELECT" && !el[x].disabled) {
            list.push(el[x]);
        }
    }
    return list;
};
document.onkeypress = function (e) {
    if ((e || window.event).keyCode === 32) {
        if (media_player.paused) {
            media_player.play();
        }
        else {
            media_player.pause();
        }
    }
};
document.ondblclick = function () {
    if (media_player.requestFullscreen) {
        media_player.requestFullscreen();
    }
    else {
        if (media_player.mozRequestFullScreen) {
            media_player.mozRequestFullScreen();
        }
        else {
            if (media_player.webkitRequestFullscreen) {
                media_player.webkitRequestFullscreen();
            }
        }
    }
};
HTMLElement.prototype.getControls = function () {
    return [].concat(Array.prototype.slice.call(this.getElementsByTagName("input")), Array.prototype.slice.call(this.getElementsByTagName("select")));
};
window.onload = function () {
    if (settings.image_mode == 0) {
        document.getElementById("left").getElementById("image").onerror = function () {
            if (this.src.indexOf(domain) != 0) {
                this.src = domain + "/proxy/" + encodeURIComponent(btoa(this.src));
            }
        };
        document.getElementById("right").getElementById("image").onerror = function () {
            if (this.src.indexOf(domain) != 0) {
                this.src = domain + "/proxy/" + encodeURIComponent(btoa(this.src));
            }
        };
    }

    ajax_running.remove = function (val) {
        if (this.indexOf(val) > -1) {
            this.splice(this.indexOf(val), 1);
        }
        if (!this.length && !websocket) {
            websocket_connect();
        }
    };
    load_settings();
    dowload_files();
};
window.onpopstate = function (e) {
    if (e.state) {
        nav_history.go(e.state - nav_history.current);
    }
};
window.getCookie = function (name) {
    var match = document.cookie.match(new RegExp(name + "=([^;]+)"));
    if (match) {
        return match[1];
    }
};

function load_settings() {
    settings["image_mode"] = window.getCookie("image_mode") ? parseInt(window.getCookie("image_mode")) : 0;
    settings["play_mode"] = window.getCookie("play_mode") ? parseInt(window.getCookie("play_mode")) : 0;
    settings["player_mode"] = window.getCookie("player_mode") ? parseInt(window.getCookie("player_mode")) : 0;
    settings["show_fanart"] = window.getCookie("show_fanart") == "false" ? false : true;
    settings["builtin_history"] = window.getCookie("builtin_history") == "true" ? true : false;
}

function save_settings() {
    var controls = document.getElementById("web_settings").getControls();
    var x;
    for (x in controls) {
        switch (controls[x].type) {
        case "text":
            ;
        case "password":
            save_setting(atob(controls[x].id), controls[x].value);
            break;
        case "checkbox":
            save_setting(atob(controls[x].id), controls[x].checked);
            break;
        case "select-one":
            save_setting(atob(controls[x].id), controls[x].selectedIndex);
            break;
        }
    }
    load_settings();
}

function save_setting(id, value) {
    document.cookie = id + "=" + value + "; expires=Fri, 31 Dec 9999 23:59:59 GMT";
}

function dowload_files() {
    ajax_to_dict("/media/html/item.html", html, "item");
    ajax_to_dict("/media/html/dialog_info.html", html, "dialog_info");
    ajax_to_dict("/media/html/dialog_ok.html", html, "dialog_ok");
    ajax_to_dict("/media/html/dialog_yesno.html", html, "dialog_yesno");
    ajax_to_dict("/media/html/dialog_img_yesno.html", html, "dialog_img_yesno");
    ajax_to_dict("/media/html/dialog_progress.html", html, "dialog_progress");
    ajax_to_dict("/media/html/dialog_notification.html", html, "dialog_notification");
    ajax_to_dict("/media/html/dialog_select.html", html, "dialog_select");
    ajax_to_dict("/media/html/dialog_input.html", html, "dialog_input");
    ajax_to_dict("/media/html/dialog_progress_bg.html", html, "dialog_progress_bg");
    ajax_to_dict("/media/html/dialog_settings.html", html, "dialog_settings");
    ajax_to_dict("/media/html/dialog_player.html", html, "dialog_player");
    ajax_to_dict("/media/html/dialog_captcha.html", html, "dialog_captcha");
    ajax_to_dict("/media/html/dialog_firstrun.html", html, "dialog_firstrun");
};
