function get_response(data) {
    var response = JSON.parse(data);
    switch (response.action) {
    case "addDirectoryItem":
        Loading_show();
        if (response.handle != handle) {
            console.log("Intentando usar un handle no válido: " + handle);
            break;
        }
        items.items.push({
            "url": response.url,
            "label": response.label,
            "listitem": response.listitem,
            "isFolder": response.isFolder,
            "totalItems": response.totalItems
        });
        document.getElementById("loading").children[0].innerText = Math.round(items.items.length * 100 / response.totalItems) + "%";
        break;
    case "endOfDirectory":
        if (response.handle != handle) {
            console.log("Intentando usar un handle no válido: " + handle);
            break;
        }
        items.succeeded = response.succeeded;
        if (response.succeeded) {
            load_items(items.items);
            nav_history.newResponse(Array.prototype.slice.call(document.getElementById("items").children), items.category);
        }
        else {}
        Loading_hide();
        break;
    case "setPluginCategory":
        if (response.handle != handle) {
            console.log("Intentando usar un handle no válido: " + handle);
            break;
        }
        items.category = response.category
        document.getElementById('category').innerText = response.category
        break;
    case "endOfScript":
        Loading_hide();
        break;
    case "setViewMode":
        set_view(response.view);
        break;
    case "handleConnected":
        document.getElementById("version").innerHTML = "v" + response.version;
        session_id = response.id;
        var url = window.location.href.split("#")[1] ? window.location.href.split("#")[1] : "";
        if (!url && nav_history.current > -1){
            if (nav_history.confirmed){
                url = nav_history.states[nav_history.current].url
            }else{
                url = nav_history.states[nav_history.current - 1].url
                nav_history.current -=1
            }
        }

        var item = document.createElement("a");
        item.setAttribute("url", url);
        send_request(item)
        break;
    case "containerRefresh":
        if (!nav_history.confirmed) {
            url = nav_history.states[nav_history.current - 1].url;
            nav_history.current -=1;
        }
        else {
            url = nav_history.states[nav_history.current].url;

        }

        var item = document.createElement("a");
        item.setAttribute("url", url);
        setTimeout(send_request, 100, item)
        break;
    case "Dialog.ok":
        Dialog_ok(response);
        break;
    case "Dialog.notification":
        Dialog_notification(response);
        break;
    case "Dialog.yesno":
        Dialog_yesno(response);
        break;
    case "Dialog.img_yesno":
        Dialog_img_yesno(response);
        break;
    case "Dialog.select":
        Dialog_select(response);
        break;
    case "DialogProgressBG.create":
        Dialog_progress_bg(response);
        break;
    case "DialogProgressBG.update":
        var el = document.getElementById(response.dialog_id);
        el.getElementById("title").innerHTML = response.heading;
        el.getElementById("content").innerHTML = response.message;
        el.getElementById("percent").innerText = parseInt(response.percent) + "%";
        break;
    case "DialogProgressBG.close":
        el = document.getElementById(response.dialog_id);
        if (el) {
            el.parentNode.removeChild(el);
        }
        break;
    case "DialogProgress.create":
        Dialog_progress(response);
        break;
    case "DialogProgress.update":
        el = document.getElementById(response.dialog_id);
        var message = response.line1.replace(/\n/g, "<br/>");
        if (response.line2) {
            message += "</br>" + response.line2.replace(/\n/g, "<br/>");
        }
        if (response.line3) {
            message += "</br>" + response.line3.replace(/\n/g, "<br/>");
        }
        el.getElementById("content").innerHTML = message;
        el.getElementById("percent").style.width = response.percent + "%";
        break;
    case "DialogProgress.close":
        el = document.getElementById(response.dialog_id);
        if (el) {
            el.parentNode.removeChild(el);
        }
        break;
    case "DialogProgress.iscanceled":
        send_data({
            "id": response.id,
            "result": Boolean(document.getElementById(response.dialog_id).canceled)
        });
        break;
    case "isPlaying":
        send_data({
            "id": response.id,
            "result": !!document.getElementById(response.play_id)
        });
        break;
    case "Keyboard":
        Dialog_input(response);
        break;
    case "Dialog.numeric":
        Dialog_numeric(response);
        break;
    case "Captcha":
        Dialog_captcha(response);
        break;
    case "recaptcha":
        break;
    case "recaptcha_select":
        Loading_hide();
        dialog.recaptcha_select(response.id, data);
        break;
    case "play":
        Loading_hide();
        if (settings.player_mode == 0) {
            el = document.createElement("div");
            el.className = "overlay";
            el.id = response.id;
            el.innerHTML = html.dialog_select;
            el.getElementById("title").innerHTML = "Selecciona un reproductor";
            el.getElementById("close").onclick = function () {
                el.parentNode.removeChild(el);
            };
            var x;
            for (x in players) {
                var a = document.createElement("a");
                a.innerHTML = players[x];
                a.href = "javascript:void(0)";
                a.onmouseover = function () {
                    this.focus();
                };
                a.onmouseout = function () {
                    this.blur();
                };
                a.id = x;
                a.onclick = function () {
                    play_method(response, this.id);
                    el.parentNode.removeChild(el);
                };
                el.getElementById("content").appendChild(a);
            }
            document.getElementsByTagName("body")[0].appendChild(el);
        }
        else {
            play_method(response, Object.keys(players)[settings.player_mode - 1]);
        }
        break;
    case "hide_loading":
        Loading_hide();
        break;
    case "show_loading":
        Loading_show();
        break;
    case "InfoWindow":
        Dialog_info(response);
        break;
    case "InfoWindow.update":
        Dialog_info(response);
        break;
    case "FirstRun":
        Dialog_firstrun(response);
        break;
    case "FirstRun.update":
        Dialog_firstrun(response);
        break;
    case "FirstRun.close":
        el = document.getElementById(response.dialog_id);
        if (el) {
            el.parentNode.removeChild(el);
        }
        Loading_hide();
        break;
    case "SettingsWindow":
        Dialog_settings(response);
        break;
    case "SettingsWindow.custom_buttom":
        el = document.getElementById(response.dialog_id);
        el.custom_button = response.custom_button;
        for (x in el.custom_button.values) {
            id = btoa(x);
            if (el.getElementById(id).getElementById(id).type == "checkbox") {
                el.getElementById(id).getElementById(id).checked = el.custom_button.values[x];
            }
            else {
                el.getElementById(id).getElementById(id).value = el.custom_button.values[x];
            }
            el.getElementById(id).getElementById(id).onchange.apply(el.getElementById(id).getElementById(id));
        }
        check_custom_button(el);
        break;
    default:
        break;
    }
}

function custom_button(data) {
    if (data == null) {
        var controls = document.getElementById("window_settings").getControls();
        var x;
        for (x in controls) {
            switch (controls[x].type) {
            case "text":
                controls[x].value = default_settings[controls[x].id];
                break;
            case "password":
                controls[x].value = default_settings[controls[x].id];
                break;
            case "checkbox":
                value = default_settings[controls[x].id];
                if (value == true) {
                    value = "checked";
                }
                else {
                    value = "";
                }
                controls[x].checked = value;
                break;
            case "select-one":
                if (controls[x].name == "enum") {
                    controls[x].selectedIndex = default_settings[controls[x].id];
                }
                else {
                    if (controls[x].name == "labelenum") {
                        controls[x].value = default_settings[controls[x].id];
                    }
                }
                break;
            }
            controls[x].onchange();
        }
    }
    else {
        send_data({
            "id": document.getElementById("window_settings").RequestID,
            "result": "custom_button"
        });
        if (data["close"] == true) {
            dialog.closeall();
        }
    }
}

function info_window(comando) {
    send_data({
        "id": document.getElementById("window_info").RequestID,
        "result": comando
    });
}

function get_setting(id, module, value) {
    var xhr = new XMLHttpRequest;
    xhr.open("POST", "/", false);
    xhr.send(JSON.stringify({
        "id": id,
        "module": module,
        "value": value
    }));
    return JSON.parse(xhr.responseText);
}

function evaluate(el, index, cond) {
    var res = true;
    if (typeof cond == "boolean") {
        return cond;
    }
    var regex = /(!)?(eq|gt|lt|set)?\(([^,]+),[\"']?([^)'\"]*)['\"]?\)[ ]*([+|])?/g;
    for (;
        (m = regex.exec(cond)) !== null;) {
        if (m.index === regex.lastIndex) {
            regex.lastIndex++;
        }
        var neg = m[1];
        var operator = m[2];
        var c_id = parseInt(m[3]);
        var value = m[4];
        var next_op = m[5];
        if (isNaN(c_id)) {
            return false;
        }
        if (index + c_id < 0 || index + c_id >= el.controls.length) {
            return false;
        }
        control_value = el.controls[index + c_id].value;
        operators = {
            "lt": function (x, z) {
                return typeof x == "number" && (typeof z == "number" && x < z);
            },
            "gt": function (x, z) {
                return typeof x == "number" && (typeof z == "number" && x > z);
            },
            "eq": function (x, z) {
                return x == z;
            },
            "set": function (x, z) {
                return get_setting(z, el.module, x);
            }
        };
        if (value == "true") {
            value = true;
        }
        if (value == "false") {
            value = False;
        }
        if (!isNaN(parseInt(value))) {
            value = parseInt(value);
        }
        res = operators[operator](control_value, value);
        if (neg) {
            res = !res;
        }
        if (next_op == "|" && res === true) {
            break;
        }
        if (next_op == "+" && res === false) {
            break;
        }
    }
    return res;
}

function check_custom_button(el) {
    if (el.custom_button) {
        el.getElementById("custom").innerHTML = el.custom_button.label;
        el.getElementById("custom").onclick = function () {
            send_data({
                "id": el.id,
                "result": {
                    "action": "custom_button",
                    "values": el.controls
                }
            });
        };
    }
    else {
        if (el.controls.filter(function (i) {
                return i.type != "label";
            }).key("type").unique("bool")) {
            if (el.controls.filter(function (i) {
                    return i.type != "label";
                }).key("value").all()) {
                el.getElementById("custom").innerHTML = "Ninguno";
                el.getElementById("custom").onclick = function () {
                    var x;
                    for (x in el.controls) {
                        if (el.controls[x].type == "bool") {
                            el.controls[x].value = false;
                            el.getElementById(el.controls[x].id).getElementById(el.controls[x].id).checked = false;
                        }
                    }
                    check_custom_button(el);
                };
            }
            else {
                el.getElementById("custom").innerHTML = "Todos";
                el.getElementById("custom").onclick = function () {
                    var x;
                    for (x in el.controls) {
                        if (el.controls[x].type == "bool") {
                            el.controls[x].value = true;
                            el.getElementById(el.controls[x].id).getElementById(el.controls[x].id).checked = true;
                        }
                    }
                    check_custom_button(el);
                };
            }
        }
        else {
            el.getElementById("custom").style.display = "none";
        }
    }
}

function default_values(el) {
    var x;
    for (x in el.controls) {
        a = el.getElementById(el.controls[x].id);
        ctrl = a.getElementById(el.controls[x].id);
        switch (el.controls[x].type) {
        case "text":
            ;
        case "file":
            ;
        case "folder":
            ;
        case "list":
            ctrl.value = el.controls[x]["default"];
            el.controls[x].value = el.controls[x]["default"];
            break;
        case "bool":
            ctrl.checked = el.controls[x]["default"];
            el.controls[x].value = el.controls[x]["default"];
            break;
        }
    }
    evaluate_controls(el);
}

function evaluate_controls(el, control_changed) {
    if (typeof control_changed != "undefined") {
        var x;
        for (x in el.controls) {
            if (el.controls[x].id == control_changed.id) {
                switch (control_changed.type) {
                case "text":
                    el.controls[x].value = control_changed.value;
                    break;
                case "password":
                    el.controls[x].value = control_changed.value;
                    break;
                case "checkbox":
                    el.controls[x].value = control_changed.checked;
                    break;
                case "select-one":
                    if (control_changed.mode == 'label'){
                        if (el.controls[x].values){
                            el.controls[x].value = el.controls[x].values[control_changed.selectedIndex];
                        }else{
                            el.controls[x].value = el.controls[x].lvalues[control_changed.selectedIndex];
                        }
                    }else{
                        el.controls[x].value = control_changed.selectedIndex;
                    }
                    break;
                }
                break;
            }
        }
    }
    for (x in el.controls) {
        set_visible(el.getElementById(el.controls[x].id), evaluate(el, parseInt(x), el.controls[x].visible));
        set_enabled(el.getElementById(el.controls[x].id), evaluate(el, parseInt(x), el.controls[x].enabled));
    }
}

function set_visible(element, visible) {
    if (visible) {
        element.style.display = "block";
    }
    else {
        element.style.display = "none";
    }
}

function set_enabled(element, enabled) {
    var el = element.getElementById(element.id);
    if (enabled) {
        element.classList.remove("disabled");
    }
    else {
        element.classList.add("disabled");
    }
    if (el) {
        el.disabled = !enabled;
    }
};
