function show_item_info(item) {
    var art = item.getElementById("art").src;
    var label = item.getAttribute("label");
    var plot = item.getAttribute("plot") || "Información no diponible";
    if (settings.show_fanart){
        document.getElementById("items").style.backgroundImage = "linear-gradient(rgba(0,93,124,0.8),rgba(0,93,124,0.8)), url(" + item.getAttribute("fanart") + ")";
    }else{
        document.getElementById("items").style.backgroundImage = "";
    }

    if (view == "icon") {
        var el = document.getElementById("left");
        el.getElementById("image").src = art;
        el.getElementById("label").innerHTML = label;
        el.getElementById("plot").setValue(plot);
    }
    if (view == "thumb") {
        el = document.getElementById("left");
        el.getElementById("image").src = art;
        el.getElementById("label").innerHTML = label;
        el.getElementById("plot").setValue(plot);
    }
    if (view == "poster") {
        el = document.getElementById("left");
        el.getElementById("image").src = art;
        el.getElementById("label").innerHTML = label;
        el.getElementById("plot").setValue(plot);
    }
    if (view == "thumb_label") {
        el = document.getElementById("left");
        el.getElementById("image").src = art;
        el.getElementById("label").innerHTML = label;
        el.getElementById("plot").setValue(plot);
    }
    if (view == "list") {
        el = document.getElementById("left");
        el.getElementById("label").innerHTML = label;
        el.getElementById("plot").setValue(plot);
        el.getElementById("image").src = art;
    }
    if (view == "list_info") {
        el = document.getElementById("left");
        el.getElementById("label").innerHTML = label;
        el.getElementById("plot").setValue(plot);
        el = document.getElementById("right");
        el.getElementById("image").src = art;
    }
    if (view == "season") {
        el = document.getElementById("top");
        el.getElementById("tvshow").innerHTML = item.getAttribute("tvshowtitle");
        el.getElementById("date").innerHTML = item.getAttribute("year");
        el.getElementById("plot").setValue(item.getAttribute("plot"));
        el.getElementById("title").innerHTML = item.getAttribute("title");
        el.getElementById("season").innerHTML = item.getAttribute("season");
        el.getElementById("episodes").innerHTML = item.getAttribute("episode");
    }
}

function set_view(v) {
    if (["list", "list_info", "icon", "poster", "thumb", "thumb_label", "season"].indexOf(v) == -1) {
        v = "list";
    }
    view = v;
    document.getElementById("content").className = view;
}

function play_method(response, player) {
    if (settings.play_mode == 0 && (new RegExp("^(.+://)")).test(response.url)) {
        var el = document.createElement("div");
        el.className = "overlay";
        el.id = response.id;
        el.innerHTML = html.dialog_select;
        el.getElementById("title").innerHTML = "Metodo de reproducción";
        el.getElementById("close").onclick = function () {
            el.parentNode.removeChild(el);
        };
        var x;
        for (x in ["Directo", "Indirecto"]) {
            var a = document.createElement("a");
            a.innerHTML = ["Directo", "Indirecto"][x];
            a.href = "javascript:void(0)";
            a.id = x;
            a.onclick = function () {
                play_video(response, player, parseInt(this.id));
                el.parentNode.removeChild(el);
            };
            el.getElementById("content").appendChild(a);
        }
        document.getElementsByTagName("body")[0].appendChild(el);
    }
    else {
        if (settings.play_mode == 2 && (new RegExp("^(.+://)")).test(data.url)) {
            play_video(response, player, 1);
        }
        else {
            play_video(response, player, 0);
        }
    }
}

function play_video(response, player, method) {
    if (method == 1) {
        var url = domain + "/proxy/" + encodeURIComponent(btoa(response.url)) + "/video.mp4"
    }
    else {
        if (!(new RegExp("^(.+://)")).test(response.url)) {
            url = domain + "/local/" + encodeURIComponent(response.url);
        }
        else {
            url = response.url;
        }
    }
    switch (player) {
    case "play":
        window.open(url);
        break;
    case "flash_play":
        var el = document.createElement("div");
        el.className = "overlay";
        el.id = response.id;
        el.innerHTML = html.dialog_player;
        obj = document.createElement("object");
        obj.className = "media_player";
        obj.setAttribute("data", "http://releases.flowplayer.org/swf/flowplayer.commercial-3.2.18.swf");
        obj.setAttribute("type", "application/x-shockwave-flash");
        obj.id = "video_player";
        var param = document.createElement("param");
        param.name = "movie";
        param.value = "http://releases.flowplayer.org/swf/flowplayer-3.2.18.swf";
        obj.appendChild(param);
        param = document.createElement("param");
        param.name = "allowfullscreen";
        param.value = "true";
        obj.appendChild(param);
        param = document.createElement("param");
        param.name = "allowscriptaccess";
        param.value = "always";
        obj.appendChild(param);
        param = document.createElement("param");
        param.name = "flashvars";
        param.value = "config={'playerId':'flowplayer','clip':{'url':'" + url + "'},'playlist':[{'url':'" + url + "'}]}";
        obj.appendChild(param);
        el.getElementById("content").appendChild(obj);
        el.getElementById("title").innerHTML = response.listitem.info.title;
        el.getElementById("close").onclick = function () {
            el.parentNode.removeChild(el);
        };
        document.getElementsByTagName("body")[0].appendChild(el);
        break;
    case "vlc_play":
        el = document.createElement("div");
        el.className = "overlay";
        el.id = response.id;
        el.innerHTML = html.dialog_player;
        obj = document.createElement("object");
        obj.className = "media_player";
        obj.setAttribute("classid", "clsid:9BE31822-FDAD-461B-AD51-BE1D1C159921");
        obj.setAttribute("codebase", "http://downloads.videolan.org/pub/videolan/vlc/latest/win32/axvlc.cab");
        obj.id = "vlc";
        obj.setAttribute("events", "False");
        param = document.createElement("param");
        param.name = "Src";
        param.value = url;
        obj.appendChild(param);
        param = document.createElement("param");
        param.name = "ShowDisplay";
        param.value = "True";
        obj.appendChild(param);
        param = document.createElement("param");
        param.name = "AutoLoop";
        param.value = "no";
        obj.appendChild(param);
        param = document.createElement("param");
        param.name = "AutoPlay";
        param.value = "yes";
        obj.appendChild(param);
        var embed = document.createElement("embed");
        embed.className = "media_player";
        embed.setAttribute("type", "application/x-google-vlc-plugin");
        embed.setAttribute("name", "vlcfirefox");
        embed.setAttribute("autoplay", "yes");
        embed.setAttribute("loop", "no");
        embed.setAttribute("target", url);
        obj.appendChild(embed);
        el.getElementById("title").innerHTML = response.listitem.info.title;
        el.getElementById("close").onclick = function () {
            el.parentNode.removeChild(el);
        };
        document.getElementsByTagName("body")[0].appendChild(el);
        el.getElementById("content").appendChild(obj);
        break;
    case "html_play":
        el = document.createElement("div");
        el.className = "overlay";
        el.id = response.id;
        el.innerHTML = html.dialog_player;
        obj = document.createElement("video");
        obj.className = "media_player";
        obj.setAttribute("data", "http://releases.flowplayer.org/swf/flowplayer-3.2.18.swf");
        obj.setAttribute("type", "application/x-mplayer2");
        obj.setAttribute("autoplay", "true");
        obj.setAttribute("controls", "true");
        obj.setAttribute("src", url);
        el.getElementById("content").appendChild(obj);
        el.getElementById("title").innerHTML = response.listitem.info.title;
        el.getElementById("close").onclick = function () {
            el.parentNode.removeChild(el);
        };
        document.getElementsByTagName("body")[0].appendChild(el);
        break;
    }
}

function show_images() {
    var container = document.getElementById("items");
    var items = container.getElementsByTagName("a");
    var end = container.offsetTop + container.offsetHeight + container.scrollTop;
    var start = container.offsetTop + container.scrollTop;
    var x = 0;
    for (; x < items.length; x++) {
        if (items[x].offsetTop + items.offsetHeight <= start) {
            continue;
        }
        if (items[x].offsetTop <= end) {
            if (!items[x].getElementById("art").src) {
                items[x].getElementById("art").src = get_art(items[x]);
            }
        }
        else {
            break;
        }
    }
}

function get_art(item) {
    switch (view) {
    case "list":
        return item.getAttribute("poster") || (item.getAttribute("thumb") || (item.getAttribute("icon") || "http://www.mediaexplorer.tk/content/images/icon/folder.png"));
    case "icon":
        return item.getAttribute("icon") || "http://www.mediaexplorer.tk/content/images/icon/folder.png";
    case "thumb_label":
    case "thumb":
        return item.getAttribute("thumb") || "http://www.mediaexplorer.tk/content/images/icon/folder.png";

    case "season":
    case "list_info":
    case "poster":
        return item.getAttribute("poster") || "http://www.mediaexplorer.tk/content/images/icon/folder.png";
    default:
        return item.getAttribute("icon") || "http://www.mediaexplorer.tk/content/images/icon/folder.png";
    }
}

function context_menu(item) {
    var el = document.createElement("div");
    el.className = "overlay";
    el.id = "context";
    el.innerHTML = html.dialog_select;
    el.getElementById("title").innerHTML = "";
    el.getElementById("close").onclick = function () {
        el.parentNode.removeChild(el);
    };
    var x;
    for (x in item.context) {
        var a = document.createElement("a");
        a.innerHTML = item.context[x][0];
        a.href = "javascript:void(0)";
        a.setAttribute("url", item.context[x][1]);
        a.onclick = function () {
            send_request(this);
            el.parentNode.removeChild(el);
        };
        el.getElementById("content").appendChild(a);
    }
    document.getElementsByTagName("body")[0].appendChild(el);
    el.getElementById("content").children[0].focus();
}

function load_items(items) {
    var range = document.createRange();
    range.selectNodeContents(document.getElementById("items"));
    range.deleteContents();

    if (nav_history.current > 0 || nav_history.states[nav_history.current].url) {
        var div = document.createElement("div");
        div.innerHTML = html.item;
        var it = div.children[0];
        it.setAttribute("action", "back");
        it.setAttribute("poster", "http://www.mediaexplorer.tk/content/images/poster/previous.png");
        it.setAttribute("icon", "http://www.mediaexplorer.tk/content/images/icon/previous.png");
        it.setAttribute("thumb", "http://www.mediaexplorer.tk/content/images/thumb/previous.png");
        it.setAttribute("fanart", "http://www.mediaexplorer.tk/content/images/fanart/mediaexplorer.jpg");
        it.setAttribute("label", '...');
        it.onfocus = function () {
            show_item_info(this);
        };
        it.onclick = function () {
            send_request(this);
        };
        it.getElementById("label").setValue("...");
        document.getElementById("items").appendChild(it);
    }
    var x;
    for (x in items) {
        var item = items[x];
        if (settings.image_mode == 2) {
            item.listitem.art.thumb = (new RegExp("^(.+://)")).test(item.listitem.art.thumb) ? domain + "/proxy/" + encodeURIComponent(btoa(item.listitem.art.thumb)) : item.listitem.art.thumb;
            item.listitem.art.poster = (new RegExp("^(.+://)")).test(item.listitem.art.poster) ? domain + "/proxy/" + encodeURIComponent(btoa(item.listitem.art.poster)) : item.listitem.art.poster;
            item.listitem.art.icon = (new RegExp("^(.+://)")).test(item.listitem.art.icon) ? domain + "/proxy/" + encodeURIComponent(btoa(item.listitem.art.icon)) : item.listitem.art.icon;
            item.listitem.art.fanart = (new RegExp("^(.+://)")).test(item.listitem.art.fanart) ? domain + "/proxy/" + encodeURIComponent(btoa(item.listitem.art.fanart)) : item.listitem.art.fanart;
        }
        div = document.createElement("div");
        div.innerHTML = html.item;
        it = div.children[0];
        it.setAttribute("url", item.url);
        it.setAttribute("label", item.listitem.label);
        var k;
        for (k in item.listitem.art) {
            it.setAttribute(k, item.listitem.art[k] || '');
        }
        for (k in item.listitem.info) {
            it.setAttribute(k, item.listitem.info[k] || '');
        }
        it.context = item.listitem.context;
        if (settings.image_mode == 0) {
            it.getElementById("art").onerror = function () {
                if (this.src && this.src.indexOf(domain) != 0) {
                    this.src = domain + "/proxy/" + encodeURIComponent(btoa(this.src));
                }
                else {
                    this.src = "http://www.mediaexplorer.tk/content/images/icon/folder.png";
                }
            };
        }
        it.oncontextmenu = function () {
            context_menu(this);
            return false;
        };
        it.onfocus = function () {
            show_item_info(this);
        };
        it.onclick = function () {
            send_request(this);
        };
        it.getElementById("label").setValue(item.listitem.label);
        document.getElementById("items").appendChild(it);
    }
    document.getElementById("items").onscroll = function () {
        show_images();
    };
    document.getElementById("items").scrollTop = nav_history.states[nav_history.current].scroll ? nav_history.states[nav_history.current].scroll : 0;
    document.getElementById("items").children[nav_history.states[nav_history.current].focus ? nav_history.states[nav_history.current].focus : 0].focus();

    show_images();

};
